REM This script is for standard releases. The Lua code is downsized using lstrip.
REM For debugging, rather use makeiso_for_debugging.bat, because line numbers are not preserved with this one.

REM Get newest executable of Saturn Lua Player
copy ..\..\build\saturn\cd\0.bin cd\

REM Get some tools needed
copy ..\..\tools\mkisofs.exe .
copy ..\..\tools\cygwin1.dll .
copy ..\..\tools\lstrip\lstrip.exe .

REM Set the Lua script to be executed by Saturn Lua Player
REM Downsize it to reduce memory consumption
lstrip cd/0_orig.lua > cd/0.lua

REM Create ISO CD image
mkisofs -quiet -sysid "SEGA SATURN" -volid "SaturnApp" -volset "SaturnApp" -publisher "SEGA ENTERPRISES, LTD." -preparer "SEGA ENTERPRISES, LTD." -appid "SaturnApp" -abstract "ABS.TXT" -copyright "CPY.TXT" -biblio "BIB.TXT" -generic-boot ../ip.bin -full-iso9660-filenames -o sample.iso cd

REM Delete temporary copies of tools
del mkisofs.exe
del cygwin1.dll
del lstrip.exe

REM PAUSE
