/*-------------------------------------------------------------------------*/
/*      Workarea assignment customize file                                 */
/*          for SGL ver. 2.10 (default)                                    */
/*                                                                         */
/*-------------------------------------------------------------------------*/

#include	"sl_def.h"

//#include    "sprite.h"

/*---- [1.This part must not be modified] ---------------------------------*/
#define		SystemWork		0x060ffc00			/* System Variable         */

/*---- [2.This part must not be modified] ---------------------------------*/

#if 0// POS original, MAX_SPRITES being 28
#define		MAX_VERTICES	MAX_SPRITES*4 // 5000	/* number of vertices that can be used */
#define		MAX_POLYGONS	MAX_SPRITES // 4000	/* number of vertices that can be used */
#define		MAX_EVENTS		 0	/* number of events that can be used   */
#define		MAX_WORKS		 0 	/* number of works that can be used    */
#define		WORK_AREA		0x060f8e00			/* SGL Work Area, assume max 28 Sprites, (28+6)*12=0x198 -> 0x200 boundry needed      0x060e0000, don't use: 0x060f8fc0, it crashes when 6 or more sprites are displayed (SCU indirect DMA boundry!)     */
#endif

#if 0// works with MAX_SPRITES up to 36
#define		MAX_VERTICES	MAX_SPRITES*4 // 5000	/* number of vertices that can be used */
#define		MAX_POLYGONS	MAX_SPRITES // 4000	/* number of vertices that can be used */
#define		MAX_EVENTS		 1	/* number of events that can be used   */
#define		MAX_WORKS		 1 	/* number of works that can be used    */
// to make it fit for up to MAX_SPRITES=36 
#define		WORK_AREA		0x060f8600			/* SGL Work Area, assume max 36 Sprites, (36+6)*12=0x1F8 -> 0x200 boundry needed      0x060e0000, don't use: 0x060f8fc0, it crashes when 6 or more sprites are displayed (SCU indirect DMA boundry!)     */
#endif

#if 0// works with MAX_SPRITES up to 79
#define		MAX_VERTICES	MAX_SPRITES*4 // 5000	/* number of vertices that can be used */
#define		MAX_POLYGONS	MAX_SPRITES // 4000	/* number of vertices that can be used */
#define		MAX_EVENTS		 1	/* number of events that can be used   */
#define		MAX_WORKS		 1 	/* number of works that can be used    */
// to make it fit for up to MAX_SPRITES=79 
#define		WORK_AREA		0x060F6800			/* SGL Work Area, assume max 36 Sprites, (79+6)*12<=0x400 -> 0x400 boundry needed      0x060e0000, don't use: 0x060f8fc0, it crashes when 6 or more sprites are displayed (SCU indirect DMA boundry!)     */
#endif

#if 0// works with MAX_SPRITES up to 335
#define		MAX_VERTICES	MAX_SPRITES*3 // 5000	/* number of vertices that can be used */
#define		MAX_POLYGONS	MAX_SPRITES // 4000	/* number of vertices that can be used */
#define		MAX_EVENTS		 1	/* number of events that can be used   */
#define		MAX_WORKS		 1 	/* number of works that can be used    */ 
#define		WORK_AREA		0x060EC000			/* SGL Work Area, assume max 335 Sprites, (335+6)*12<=0x1000 -> 0x1000 boundry needed      0x060e0000, don't use: 0x060f8fc0, it crashes when 6 or more sprites are displayed (SCU indirect DMA boundry!)     */
#endif

#if 0// works with MAX_SPRITES up to 676
#define		MAX_VERTICES	MAX_SPRITES*3 // 5000	/* number of vertices that can be used */
#define		MAX_POLYGONS	MAX_SPRITES // 4000	/* number of vertices that can be used */
#define		MAX_EVENTS		 1	/* number of events that can be used   */
#define		MAX_WORKS		 1 	/* number of works that can be used    */
#define		WORK_AREA		0x060DE000			/* SGL Work Area, assume max 676 Sprites, (676+6)*12<=0x2000 -> 0x2000 boundry needed      0x060e0000, don't use: 0x060f8fc0, it crashes when 6 or more sprites are displayed (SCU indirect DMA boundry!)     */
#endif

#if 0// works with MAX_SPRITES up to 1024, possibly more (1359 to much)
#define		MAX_VERTICES	MAX_SPRITES*2 // 5000	/* number of vertices that can be used */
#define		MAX_POLYGONS	MAX_SPRITES // 4000	/* number of vertices that can be used */
#define		MAX_EVENTS		 1	/* number of events that can be used   */
#define		MAX_WORKS		 1 	/* number of works that can be used    */
#define		WORK_AREA		0x060D4000			/* SGL Work Area, assume max 1359 Sprites, (1359+6)*12<=0x4000 -> 0x4000 boundry needed      0x060e0000, don't use: 0x060f8fc0, it crashes when 6 or more sprites are displayed (SCU indirect DMA boundry!)     */
#endif

#if 1// alignment works with MAX_SPRITES up to 2724 (1536 needed for verified)
#define		MAX_VERTICES	(2304+976) /* number of vertices that can be used */
#define		MAX_POLYGONS	(1536+64) /* number of vertices that can be used */
#define		MAX_EVENTS		 1	/* number of events that can be used   */
#define		MAX_WORKS		 1 	/* number of works that can be used    */
#define		WORK_AREA		0x060C0000			/* SGL Work Area, assume max 2724 Sprites, (2724+6)*12<=0x8000 -> 0x8000 boundry needed      0x060e0000, don't use: 0x060f8fc0, it crashes when 6 or more sprites are displayed (SCU indirect DMA boundry!)     */
#endif
//free bytes: 23048
//--> 198 Polygons
//--> 1440 Vertices
//116 per POLYGON
//16 per VERTEX

#if 0
#define		MAX_VERTICES	500	/* number of vertices that can be used */
#define		MAX_POLYGONS	500	/* number of vertices that can be used */
#define		MAX_EVENTS		1	/* number of events that can be used   */
#define		MAX_WORKS		1 	/* number of works that can be used    */
#define		WORK_AREA		0x060C0000			/* SGL Work Area  */
#endif

#if 0
#define		MAX_VERTICES	3000//5000	/* number of vertices that can be used */
#define		MAX_POLYGONS	3000//4000	/* number of vertices that can be used */
#define		MAX_EVENTS		1//64   	/* number of events that can be used   */
#define		MAX_WORKS		1//256     /* number of works that can be used    */
#define		WORK_AREA		0x06080000			/* SGL Work Area           */
#endif

#define		trans_list		0x060fb800			/* DMA Transfer Table      */
#define		pcmbuf			SoundRAM+0x78000	/* PCM Stream Address      */
#define		PCM_SIZE		0x8000				/* PCM Stream Size         */

#define		master_stack	SystemWork			/* MasterSH2 StackPointer  */
#define		slave_stack		0x06001e00			/* SlaveSH2  StackPointer  */

/*---- [3.Macro] ----------------------------------------------------------*/
#define		_Byte_			sizeof(Uint8)
#define		_Word_			sizeof(Uint16)
#define		_LongWord_		sizeof(Uint32)
#define		_Sprite_		(sizeof(Uint16) * 18)

#define		AdjWork(pt,sz,ct)	(pt + (sz) * (ct))

/*---- [4.Work Area] ------------------------------------------------------*/
    enum workarea{
        sort_list  = WORK_AREA ,
        zbuffer    = AdjWork(sort_list , _LongWord_ * 3, MAX_POLYGONS + 6) ,
        spritebuf  = AdjWork(zbuffer   , _LongWord_, 512) ,
        pbuffer    = AdjWork(spritebuf , _Sprite_, (MAX_POLYGONS + 6) * 2) ,
        clofstbuf  = AdjWork(pbuffer   , _LongWord_ * 4, MAX_VERTICES) ,
        commandbuf = AdjWork(clofstbuf , _Byte_ * 32*3, 32) ,
        NextEntry  = AdjWork(commandbuf, _LongWord_ * 8, MAX_POLYGONS)
    } ;

/*---- [5.Variable area ] -------------------------------------------------*/
    const void*   MasterStack   = (void*)(master_stack) ;
    const void*   SlaveStack    = (void*)(slave_stack) ;
    const Uint16  MaxVertices   = MAX_VERTICES ;
    const Uint16  MaxPolygons   = MAX_POLYGONS ;
    const Uint16  EventSize     = sizeof(EVENT) ;
    const Uint16  WorkSize      = sizeof(WORK) ;
    const Uint16  MaxEvents     = MAX_EVENTS ;
    const Uint16  MaxWorks      = MAX_WORKS ;
    const void*   SortList      = (void*)(sort_list) ;
    const Uint32  SortListSize  = (MAX_POLYGONS + 6) * _LongWord_ * 3 ;
    const void*   Zbuffer       = (void*)(zbuffer) ;
    const void*   SpriteBuf     = (void*)(spritebuf) ;
    const Uint32  SpriteBufSize = _Sprite_ * (MAX_POLYGONS + 6) * 2 ;
    const void*   Pbuffer       = (void*)(pbuffer) ;
    const void*   CLOfstBuf     = (void*)(clofstbuf) ;
    const void*   CommandBuf    = (void*)(commandbuf) ;
    
    const void*   WorkAreaEnd   = (void*)(NextEntry);//e2840, when #define		WORK_AREA		0x060e0000
    
    const void*   PCM_Work      = (void*)(pcmbuf) ;
    const Uint32  PCM_WkSize    = PCM_SIZE ;
    const void*   TransList     = (void*)(trans_list) ;

    EVENT  EventBuf[MAX_EVENTS] ;
    WORK   WorkBuf[MAX_WORKS] ;
    EVENT* RemainEvent[MAX_EVENTS] ;
    WORK*  RemainWork[MAX_WORKS] ;

/*------------------------------------------------------------------------*/
