
#ifndef HAVE_VBLANK_H
#define HAVE_VBLANK_H

#define			VBLK_FUNC_MAX		5
#define			VBLK_FUNC_LUA

#ifdef VBLK_FUNC_LUA
// version for Lua
#	include "lua.h"
typedef int (*vblk_func)(lua_State *L);
int vblk_check_exit(lua_State *L);
#else
// version without Lua:
typedef void (*vblk_func)();
void vblk_check_exit();
#endif

int  vblk_func_add(vblk_func f);
int  vblk_func_remove(vblk_func f);

void vblk_execute();// to be registered with slIntFunc


#endif//HAVE_VBLANK_H
