// Note: for functions not implemented in api_def_implementation.h or api_def_register,
// these defines suit to distinguish all include cases:
//	API_DO_IMPLEMENTATION
//	API_DO_DECLARATION
//	API_DO_REGISTER


#include <bget.h>
#include <SGL.H>
#include <SEGA_GFS.H>

#ifdef OPTIMIZE_FOR_SIZE

// complete: SGL
I_U8_O_B(slSetPortDir1);
I_U8_O_B(slSetPortDir2);
I_U8_O_B(slSetPortSelect1);
I_U8_O_B(slSetPortSelect2);
I_U8_O_B(slSetPortExt1);
I_U8_O_B(slSetPortExt2);
I_U8_O_B(slSetOptimize);
I_U8_O_B(slSetPortMode1);
I_U8_O_B(slSetPortMode2);
I_U8_O_B(slSndVolume);
I_U8_O_B(slSequenceOff);
I_U8_O_B(slSequencePause);
I_U8_O_B(slSequenceCont);
I_U8_O_B(slSequenceStat);
I_U8_O_B(slSequenceReset);
I_U8_O_B(slSndEffect);

// complete: SGL
I_U16_O_B(slDynamicFrame);

// complete: SGL
I_U32_O_B(slScrAutoDisp);

// complete: SGL
I_S16_O_B(slBGMTempo);
// complete: SGL
I_U8_O_V(slCurWindow);
I_U8_O_V(slSetPortData1);
I_U8_O_V(slSetPortData2);
I_U8_O_V(slSetLanguage);
I_U8_O_V(slSetSoundEffect);
I_U8_O_V(slSetSoundOutput);
I_U8_O_V(slSetHelpWindow);

// ToDo extern	Bool	slSetResultBuffer(Uint8*, PerDigital*, Uint16);


I_U8_U8_O_B(slRequestCommand);
I_U8_U8_O_B(slBGMFade);
I_U8_U8_O_B(slSndMixChange);

I_V_O_U8(slGetPortDir1);
I_V_O_U8(slGetPortDir2);
I_V_O_U8(slGetPortData1);
I_V_O_U8(slGetPortData2);
I_V_O_U8(slGetPortSelect1);
I_V_O_U8(slGetPortSelect2);
I_V_O_U8(slGetPortExt1);
I_V_O_U8(slGetPortExt2);
I_V_O_U8(slGetLanguage);
I_V_O_U8(slGetSoundEffect);
I_V_O_U8(slGetSoundOutput);
I_V_O_U8(slGetHelpWindow);
I_V_O_U8(slCheckReset);
I_V_O_U8(slGetOptimize);
I_V_O_U8(slGetPortMode1);
I_V_O_U8(slGetPortMode2);
I_V_O_U8(slSndSeqNum);

I_V_O_U8_VAR(Per_Connect1);
I_V_O_U8_VAR(Per_Connect2);

I_V_O_Smpc_Status(Smpc_Status);

I_U32_O_U32(slHex2Dec);
I_U32_O_U32(slDec2Hex);
I_AN_O_U16(slAng2Hex);
I_AN_O_U16(slAng2Dec);

I_V_O_V(slTVOn);
I_V_O_V(slTVOff);

I_V_O_V(slInitPeripheral);
I_V_O_V(slInitMatrix);

I_V_O_V(slInitEvent);
I_V_O_V(slInitSynch);

I_V_O_B(slBGMPause);
I_V_O_B(slBGMCont);
I_V_O_B(slBGMOff);
I_V_O_B(slSoundAllOff);
I_V_O_B(slSoundAllPause);
I_V_O_B(slSoundAllCont);
I_V_O_B(slDSPOff);
I_V_O_B(slCDDAOff);

I_U16_O_V(slCurScrn);
I_U16_O_V(slCurColor);
I_U16_O_V(set_vbar);
I_U16_O_V(reset_vbar);
I_U16_O_V(slZdspLevel);
I_U16_O_V(slColRAMMode);
I_U16_O_V(slVRAMMode);
I_U16_O_V(slPlaneNbg0);
I_U16_O_V(slPlaneNbg1);
I_U16_O_V(slPlaneNbg2);
I_U16_O_V(slPlaneNbg3);
I_U16_O_V(slPlaneRA);
I_U16_O_V(slPlaneRB);
I_U16_O_V(slOverRA);
I_U16_O_V(slOverRB);
I_U16_O_V(slCurRpara);
I_U16_O_V(slRparaMode);

I_U16_O_V(slSetTVMode);
I_U16_O_V(slSetScrTVMode);
I_U16_O_V(slSetSprTVMode);

I_U16_O_V(slSetGouraudColor);
I_U16_O_V(slSetAmbient);
I_U16_O_V(slSetFlatColor);

I_S32_O_V(SYS_Exit);
I_S32_O_V(SYS_CheckTrack);

I_V_O_U16(slGetHCount);
I_V_O_U16(slGetVCount);

I_U16_U16_O_V(slCharNbg0);
I_U16_U16_O_V(slCharNbg1);
I_U16_U16_O_V(slCharNbg2);
I_U16_U16_O_V(slCharNbg3);
I_U16_U16_O_V(slCharRbg0);
I_U16_U16_O_V(slZoomMode);

I_U16_U16_O_V(slExtSignal);
I_U16_U16_O_V(slBMPalette);

I_Vx_O_V(slLineScrollTable0);
I_Vx_O_V(slLineScrollTable1);
I_Vx_O_V(slVCellTable);
I_Vx_O_V(slScrAscSet);
I_Vx_O_V(slWaitSound);

I_U32_U32_U32_U32_O_V(slScrCycleSet);
I_U8_U8_S8_S8_O_B(slCDDAOn);

I_S32_S32_O_S32(GFS_GetFad);

I_S32_O_S32(GFS_ConvTno);

I_Vx_O_B(GFS_NwIsComplete);
I_Vx_O_B(GFS_IsEof);
I_Vx_O_V(GFS_Close);
I_Vx_O_S32(GFS_Tell);
I_Vx_O_S32(GFS_GetNumCdbuf);
I_Vx_O_S32(GFS_NwStop);
I_Vx_O_S32(GFS_CdMovePickup);


I_Vx_S32_O_S32(GFS_ByteToSct);
I_Vx_S32_O_S32(GFS_NwCdRead);
I_Vx_S32_O_S32(GFS_SetGmode);
I_Vx_S32_O_S32(GFS_SetTmode);
I_Vx_S32_O_S32(GFS_SetReadPara);
I_Vx_S32_O_S32(GFS_SetTransPara);

I_Vx_S32_Vx_S32_O_S32(GFS_Fread);
I_Vx_S32_Vx_S32_O_S32(GFS_NwFread);

I_V_O_V(GFS_Reset);

I_Vx_S32_S32_O_S32(GFS_Seek);
I_Vx_O_S32(GFS_NameToId);
I_S32_O_Vx(GFS_IdToName);

I_Vx_S32_O_V(bpool);

I_Vx_U32_U32_Vx_O_V(slInitGouraud);

extern Uint16 TotalPolygons, DispPolygons, TotalVertices;
I_V_O_U16_VAR(TotalPolygons);
I_V_O_U16_VAR(DispPolygons);
I_V_O_U16_VAR(TotalVertices);
I_V_O_U16_VAR(MaxVertices);
I_V_O_U16_VAR(MaxPolygons);

#include <SEGA_BUP.H>
I_U32_O_S32(BackUpFormat);
I_U32_STR_O_S32(BackUpDelete);

I_V_O_B(slMasterOn);
I_V_O_B(slSlaveOn);
I_V_O_B(slSlaveOff);
I_V_O_B(slSoundOn);
I_V_O_B(slSoundOff);
I_V_O_B(slCDOn);
I_V_O_B(slCDOff);
I_V_O_B(slSystemReset);
I_V_O_B(slClockChange352);
I_V_O_B(slClockChange320);
I_V_O_B(slNMIRequest);
I_V_O_B(slResetEnable);
I_V_O_B(slResetDisable);
I_V_O_B(slGetStatus);
I_V_O_B(slGetPeripheral);
I_V_O_B(slSetSmpcMemory);
I_V_O_B(slSetDateTime);

I_V_O_B(slMasterOnWait);
I_V_O_B(slSlaveOnWait);
I_V_O_B(slSlaveOffWait);
I_V_O_B(slSoundOnWait);
I_V_O_B(slSoundOffWait);
I_V_O_B(slCDOnWait);
I_V_O_B(slCDOffWait);
I_V_O_B(slNMIRequestWait);
I_V_O_B(slResetEnableWait);
I_V_O_B(slResetDisableWait);
I_V_O_B(slSetSmpcMemoryWait);
I_V_O_B(slSetDateTimeWait);

I_U16_U16_U16_O_Vx(slLocateNbg);
I_U16_U16_U16_O_Vx(slLocatePage);

I_Vx_O_V(slRparaInitSet);

I_Vx_Vx_Vx_Vx_O_V(slMapNbg0);
I_Vx_Vx_Vx_Vx_O_V(slMapNbg1);
I_Vx_Vx_Vx_Vx_O_V(slMapNbg2);
I_Vx_Vx_Vx_Vx_O_V(slMapNbg3);

// no Null pointer check
I_VX_VX_U16_O_V(slPageNbg0);
I_VX_VX_U16_O_V(slPageNbg1);
I_VX_VX_U16_O_V(slPageNbg2);
I_VX_VX_U16_O_V(slPageNbg3);
I_VX_VX_U16_O_V(slPageRbg0);

extern void Cel2VRAM( Uint8 *Cel_Data , void *Cell_Adr , Uint32 suu );
extern void Pal2CRAM( Uint16 *Pal_Data , void *Col_Adr , Uint32 suu );

I_U8x_Vx_U32_O_V(Cel2VRAM);
I_U16x_Vx_U32_O_V(Pal2CRAM);

extern void set_texture(TEXTURE *txtbl, PICTURE *pcptr, Uint32 NbPicture);

I_Vx_Vx_U32_O_V(set_texture);

#else




// special treatment
I_U8_O_Smpc_Peripheral(Smpc_Peripheral);

I_AN_O_FX(slSin);
I_AN_O_FX(slCos);
I_AN_O_FX(slTan);
I_AN_O_FX(slAng2FX);

I_FX_FX_O_AN(slAtan);

I_U32_O_U32(slSquart);

// complete: SGL
I_V_O_V(slInversMatrix);
I_V_O_V(slTransposeMatrix);
I_V_O_V(slScrMatSet);
I_V_O_V(slScrMatConv);
I_V_O_V(slExecuteEvent);
I_V_O_V(slDMAWait);
I_V_O_V(DMA_CpuAllStop);
I_V_O_V(slSynch);
I_V_O_V(slCashPurge);
I_V_O_V(slSndFlush);
I_V_O_V(slGouraudTblCopy);

// complete: SGL
I_V_O_B(slIntBackCancel);
I_V_O_B(slClearReset);
I_V_O_B(slPushMatrix);
I_V_O_B(slPopMatrix);
I_V_O_B(slPushUnitMatrix);
I_V_O_B(slIncMatrixPtr);
I_V_O_B(slDecMatrixPtr);
I_V_O_B(slCopyMatrix);

I_AN_O_V(slRotX);
I_AN_O_V(slRotY);
I_AN_O_V(slRotZ);
I_AN_O_V(slPerspective);
I_AN_O_V(slZrotR);

I_FX_O_V(slSetScreenDist);

// complete: SGL
I_FX_FX_O_V(slRotXSC);
I_FX_FX_O_V(slRotYSC);
I_FX_FX_O_V(slRotZSC);
I_FX_FX_O_V(slScrPosNbg0);
I_FX_FX_O_V(slScrPosNbg1);
I_FX_FX_O_V(slScrPosNbg2);
I_FX_FX_O_V(slScrPosNbg3);
I_FX_FX_O_V(slScrMoveNbg0);
I_FX_FX_O_V(slScrMoveNbg1);
I_FX_FX_O_V(slScrMoveNbg2);
I_FX_FX_O_V(slScrMoveNbg3);
I_FX_FX_O_V(slLookR);
I_FX_FX_O_V(slDispCenterR);
I_FX_FX_O_V(slZoomNbg0);
I_FX_FX_O_V(slZoomNbg1);
I_FX_FX_O_V(slZoomR);
I_FX_FX_O_V(slScrScaleNbg0);
I_FX_FX_O_V(slScrScaleNbg1);
I_FX_FX_O_V(slScrScaleR);

I_FX_FX_O_FX(slMulFX);
I_FX_FX_O_FX(slDivFX);

I_U16_O_V(slScrTransparent);
I_U16_O_V(slLineColDisp);
I_U16_O_V(slColorCalc);
I_U16_O_V(slColorCalcMode);
I_U16_O_V(slColorCalcOn);
I_U16_O_V(slColOffsetOn);
I_U16_O_V(slColOffsetOff);
I_U16_O_V(slColOffsetAUse);
I_U16_O_V(slColOffsetBUse);
I_U16_O_V(slSpriteCCalcCond);
I_U16_O_V(slSpriteCCalcNum);
I_U16_O_V(slSpriteColMode);
I_U16_O_V(slSpriteWinMode);
I_U16_O_V(slSpriteType);
I_U16_O_V(slScrMosaicOn);
I_U16_O_V(slGradationOn);
I_U16_O_V(slShadowOn);
I_U16_O_V(slTpShadowMode);
I_U16_O_V(slOverPatRA);
I_U16_O_V(slOverPatRB);
I_U16_O_V(slColRAMOffsetNbg0);
I_U16_O_V(slColRAMOffsetNbg1);
I_U16_O_V(slColRAMOffsetNbg2);
I_U16_O_V(slColRAMOffsetNbg3);
I_U16_O_V(slColRAMOffsetRbg0);
I_U16_O_V(slColRAMOffsetSpr);
I_U16_O_V(slSpecialPrioModeNbg0);
I_U16_O_V(slSpecialPrioModeNbg1);
I_U16_O_V(slSpecialPrioModeNbg2);
I_U16_O_V(slSpecialPrioModeNbg3);
I_U16_O_V(slSpecialPrioModeRbg0);
I_U16_O_V(slSpecialCCalcModeNbg0);
I_U16_O_V(slSpecialCCalcModeNbg1);
I_U16_O_V(slSpecialCCalcModeNbg2);
I_U16_O_V(slSpecialCCalcModeNbg3);
I_U16_O_V(slSpecialCCalcModeRbg0);
I_U16_O_V(slSpecialFuncCodeA);
I_U16_O_V(slSpecialFuncCodeB);
I_U16_O_V(slSpecialFuncSelectB);
I_U16_O_V(slRparaReadCtrlRA);
I_U16_O_V(slRparaReadCtrlRB);
I_U16_O_V(slSpecialPrioBitRbg0);
I_U16_O_V(slSpecialCCalcBitRbg0);

I_U32_O_V(slScrDisp);
I_U32_O_V(slNearClipFlag);


I_S32_O_V(slDispPlaneLevel);
I_S32_O_V(slWindowClipLevel);

I_S8_O_V(slClearBitMap);

I_U8_S8_O_B(slSequencePan);

I_U8_S16_O_B(slSequenceTempo);

I_V_O_U32(DMA_ScuResult);
I_V_O_U32(DMA_CpuResult);

I_V_O_S8(slSndPCMNum);

I_S16_S16_O_V(slFrameClipSize);
I_S16_S16_O_V(slBitMapBase);

I_S16_U16_O_V(slColRate);
I_S16_U16_O_V(slPriority);

I_U16_U16_O_V(slColOffsetScrn);
I_U16_U16_O_V(slScrMosSize);
I_U16_U16_O_V(slScrWindowMode);
I_U16_U16_O_V(slLineScrollMode);
I_U16_U16_O_V(slSpecialPrioBitN01);
I_U16_U16_O_V(slSpecialPrioBitScr);
I_U16_U16_O_V(slSpecialCCalcBitN01);
I_U16_U16_O_V(slSpecialCCalcBitScr);

// void casts to PDATA *pat automatically
I_Vx_O_B(slPutPolygon);
I_Vx_O_B(slPutPolygonS);
I_Vx_U16_O_B(slDispPolygon);

I_Vx_O_V(slBackColTable);
I_Vx_O_V(slLineColTable);
I_Vx_O_V(sl1MapRA);
I_Vx_O_V(sl1MapRB);
I_Vx_O_V(slMakeKtable);
I_Vx_O_V(slScrLineWindow0);
I_Vx_O_V(slScrLineWindow1);

// for simplicity, void pointer is automatically casted to FIXED pointer (=MATRIX)
// no null pointer check
I_VX_O_V(slUnitMatrix);
I_VX_O_V(slUnitAngle);
I_VX_O_V(slUnitTranslate);
I_VX_O_V(slRegistMatrix);

I_Vx_O_V(slLoadMatrix);
I_Vx_O_V(slMultiMatrix);
I_Vx_O_V(slGetMatrix);

I_U16_U16_U16_U16_O_V(slScrWindow0);
I_U16_U16_U16_U16_O_V(slScrWindow1);

I_S16_S16_S16_S8_O_V(slBMCircle);

I_U16_U8_U8_U8_O_B(slBGMOn);

// for simplicity, void * is automatically casted to GfsHn
I_Vx_O_S32(GFS_NwExecOne);

// ToDo SEGA_GFS.H
//	Sint32 GFS_LoadDir(Sint32 fid, GfsDirTbl *dirtbl);
//	Sint32 GFS_SetDir(GfsDirTbl *dirtbl);
//	Sint32 GFS_GetDirInfo(Sint32 fid, GfsDirId *dirrec);
//	GfsHn GFS_Open(Sint32 fid);
//	void GFS_GetFileSize(GfsHn gfs, Sint32 *sctsz, Sint32 *nsct, Sint32 *lstsz);
//	void GFS_GetFileInfo(GfsHn gfs, Sint32 *fid, Sint32 *fn, Sint32 *fsize, Sint32 *atr);
//	void    GFS_SetTrFunc(GfsHn gfs, GfsTrFunc func);
//	Uint32  *GFS_StartTrans(GfsHn gfs, Sint32 *dadr);
//	void GFS_SetErrFunc(GfsErrFunc func, void *obj);
//	void GFS_GetErrStat(GfsErrStat *stat);

I_S16_S16_S16_S16_S16_S16_S16_O_B(slWindow);
// GOURAUDTBL * is automatically casted to void *
I_U16_U16_U16_O_U16(C_RGB);

I_Vx_O_B(slPutObject);

I_U16x_O_V(slSetGouraudTbl);
I_V_O_V(PCM_VblIn);

// do these even work? pasting C macros....their name is not preserved, probably

//I_U32_O_S32(BUP_Format);
//I_U32_STR_O_S32(BUP_Delete);

I_FX_FX_FX_O_V(slScale);
I_FX_FX_FX_O_V(slRegistTranslate);
I_FX_FX_FX_O_V(slTranslate);
I_FX_FX_FX_O_V(slLoadTranslate);
I_FX_FX_FX_AN_O_V(slRotAX);

I_VC_VC_VC_O_VC(slNormalVector);
//I_VC_VC_VC_O_VC(slRevNormalVector);// somehow not implemented in SGL, although declared

I_FX_O_FX(slSquartFX);


I_Vx_U16_O_V(slKtableRA);
I_Vx_U16_O_V(slKtableRB);

I_Vx_Vx_U32_O_V(slDMACopy);

I_S16_S16_S16_O_V(slColOffsetA);
I_S16_S16_S16_O_V(slColOffsetB);

I_Vx_U16_O_V(slLine1ColSet);
I_Vx_U16_O_V(slBack1ColSet);

I_V_O_S32(STM_ExecServer);


#endif // OPTIMIZE_FOR_SIZE
